/*
 * Edelleen melko yksinkertainen C-kielinen ohjelma: laskee
 * rekursiivisesti luvun kertoman ja tulostaa sen standardiulostuloon.
 *
 * Luennolla käännettiin tämä ja ihmeteltiin syntynyttä konekielistä
 * ohjelmaa gdb-debuggerin disassemblynä. Ajettiin lähdekoodirivi
 * kerrallaan step-komennolla, ja havainnoitiin
 * aliohjelma-aktivaatioiden syntymistä kutsupinoon.
 *
 */
#include<stdio.h>

/** Palauttaa luvun n kertoman, eli esim. 9! = 9x8x7x6x5x4x3x2x1 */
int kertoma(int n){
  int edellinen;
  if (n==0) return 1;
  edellinen = kertoma(n-1);
  return n*edellinen;
}

int laske_ja_tulosta_kertoma(int n){
  int tulos;
  tulos = kertoma(n);
  printf("Luvun %d kertoma on %d.\n", n, tulos);
  return tulos;
}

/** Ns. "Pääohjelma" */
int main(int argc, char** argv){
  int luku, vastaus;
  luku = 9;
  vastaus = laske_ja_tulosta_kertoma(luku);
  return 0;
}
