#include<stdint.h>
#include<inttypes.h>
#include<stdio.h>
#include<stdbool.h>

void koktaulu_summa_alkioittain_bhen(const int64_t a[], int64_t b[], int nelem){
    /* TODO: Toteuta itse osana demoa 4!*/
}

bool koktaulu_samansisaltoisia(const int64_t a[], const int64_t b[], int nelem){
    for(int i=0; i<nelem; i++){
        if (a[i] != b[i]) return false;
    }
    return true;
}

int64_t koktaulu_summa(const int64_t taulukko[], int nelem){
  int i;
  int64_t summa = 0;
  for (i=0; i<nelem; i++){
    summa += taulukko[i];
  }
  return summa;
}

/** Täytä vakioarvolla (esimerkki taulukon käytöstä) */
void koktaulu_tayta(int64_t taulukko[], int nelem, int64_t value){
  int i;
  for (i=0; i<nelem; i++){
    taulukko[i] = value;
  }
}

/** Tulosta haluttuun tietovirtaan (esimerkki taulukosta ja virroista) */
void koktaulu_tulosta(const int64_t taulukko[], int nelem, FILE* fp){
  int i;
  for (i=0; i<nelem; i++){
      fprintf(fp,"%" PRId64 " ", taulukko[i]);
  }
  fprintf(fp,"\n");
}
