# Kurssin tehtavat

---

~~~~{#itka203ennakointi plugin="taskview"}
- title: Ennakointi
  description: |
    Tässä tehtävää ennen muita asioita kurssilla
  tasks:
    - title: kurssin nettisivuun
      type: Tutustu
      link: http://users.jyu.fi/~nieminen/kj15/
      description: varmista, että olet käyttämässä aikaasi oikeaan tarkoitukseen oikealla hetkellä
    - title: Aloitusluennolla
      type: Ole paikalla
      link: https://yousource.it.jyu.fi/itka203-kurssimateriaalikehitys/itka203-kurssimateriaali-avoin/blobs/master/luentosuunnitelma_2015.txt
      description: |
        (tai vähintään katso video ja tarkista muistiinpanot) Kerrotaan mm., miten kurssista pääsee läpi
      tasks:
        - title: 
          type: Olen tutustunut 1. luennolla ilmoitettuihin vaatimuksiin
          checkable: "tutustunut_vaatimuksiin"
          requires: ["tutustunut_vaatimuksiin"]
    - title: kurssikuvaus ja osaamistavoitteet
      type: Käy läpi
      description: Lue kurssikuvaus
      link: http://users.jyu.fi/~nieminen/kj15/osaamistavoitteet.html
      tasks:
        - title: kurssin osaamistavoitteet
          type: Olen lukenut
          link: http://users.jyu.fi/~nieminen/kj15/osaamistavoitteet.html
          checkable: "lukenut_osaamistavoitteet"
          requires: ["lukenut_osaamistavoitteet"]
        - title: 
          type: Olen päättänyt yrittää kurssin suorittamista tosissani
          checkable: "paattanut_yrittaa"
          requires: ["paattanut_yrittaa"]
~~~~

~~~~{#itka203pakolliset plugin="taskview"}
- title: Pakolliset demot
  description: |
    Pakollisia demoja tulee suunnitelman mukaan 8 kpl,
    noin viikottain, tasaisesti kurssin aikana; kuitenkin
    korkeintaan niin monta kuin ehditään julkaista siten, että
    jokaisen demon tekemiseen jää vähintään kokonainen
    kalenteriviikko aikaa. JÄRJESTELMÄÄ PILOTOIDAAN.
    Teknisia ongelmia voi tulla, ääkköset saatiin toimimaan,
    mutta välissä on defaulttitekstejä englanniksi ym.,
    palautusformaatti ja tiedostojen
    määrä saattaa elää demosta 3 alkaen ym.
    Pidetaan hauskaa ja kokeillaan! Ykkös- ja kakkosdemojen
    palautus on auki heti kurssin ekalla viikolla, kerrankin, jes!!
  tasks:
    - title: Sormet Unixiin (noin 1. viikko)
      type: Käy läpi
      description: Superpikaintro interaktiivisen shellin käyttöön
      link: /pages/d01_sormet_unixiin.rst
      tasks:
        - title: Demon 1 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässa syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d01
          requires: ["tiedostonpalautus_d01"]
    - title: Sormet Syvemmälle (Unixiin..) (noin 2. viikko)
      type: Käy läpi
      description: Superpikajatko interaktiivisen shellin käyttöön
      link: /pages/d02_sormet_syvemmalle.rst
      tasks:
        - title: Demon 2 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d02
          requires: ["tiedostonpalautus_d02"]
    - title: Sormet C:hen (noin 3. viikko)
      type: Käy läpi
      description: C-ohjelman kääntäminen, debugger, komentoriviargumentit, ympäristömuuttujat, kieliasetukset (suurin piirtein alkupuolisko v. 2014 C-demosta; uudistetut esimerkit)
      link: /pages/d03_sormet_chen.rst
      tasks:
        - title: Demon 3 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d03
          requires: ["tiedostonpalautus_d03"]
    - title: Sormet syvemmalle C:hen (noin 4. viikko)
      type: Käy läpi
      description: Pieni selviytymisopas C-kieleen. Kavennettu v. 2014 C-demosta; ministi uudistettu, C99-standardin mukainen ym.
      link: /pages/d04_c.rst
      tasks:
        - title: Demon 4 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d04
          requires: ["tiedostonpalautus_d04"]
    - title: Miniminiharkka (noin 5. viikko)
      type: Käy läpi
      description: Ohjelman jälki sekä pinokehyksen synty ja tuho
      link: /pages/d05_pinokehys.rst
      tasks:
        - title: Demon 5 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d05
          requires: ["tiedostonpalautus_d05"]
    - title: Hiukan edistyneempi skripti (noin 6. viikko)
      link: /pages/d06_skripti.rst
      type: Käy läpi
      description: Muutama ohjelmointirakenne, argumenttien käyttö
      tasks:
        - title: Demon 6 palautuslokeroon
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_d06
          requires: ["tiedostonpalautus_d06"]
    - title: Ennakkotentti (ei pakollista palautettavaa)
      type: Odota, että julkaistaan (helatorstaina klo 16:00)
      description: Tentin lopullinen muoto, mallitehtävätyypit ja pisteytys
      tasks:
        - title: 
          type: Olen tutustunut ennakkotenttiin
          checkable: "tutustunut_ennakkotenttiin"
          requires: ["tutustunut_ennakkotenttiin"]
~~~~


~~~~{#itka203bonukset plugin="taskview"}
- title: Vapaaehtoiset demot
  description: |
    Vapaaehtoisia demoja voi alkaa tekemaan noin kurssin puolivälissä
    pakollisten 1-4 jälkeen. Ne myos julkaistaan jotakuinkin siinä
    vaiheessa. Aihepiirit todennäköisesti samantyyppisiä kuin viime vuonna.
    Jokaisesta hyväksytysti palautetusta vapaaehtoisesta saa yhden
    bonuspisteen tenttiin. KAIKKIEN EI ole tarkoituskaan ehtiä tekemään
    kaikkia; valitse itsellesi mielenkiintoisimmat ja ajankäytön ahdistaessa
    keskity mieluummin ydinosaamiskohteisiin. Nämä demot liittyvät pääasiassa
    arvosanoihin 4-5 tähtääviin osaamistavoitteisiin.
  tasks:
    - title: Vaarallisia ohjelmia
      type: Käy läpi
      description: Fork-pommeja ja muistivuotoja
      link: /pages/v01_vaarallisia_ohjelmia.rst
      tasks:
        - title: Omaan palautuslokeroonsa
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v01
          requires: ["tiedostonpalautus_v01"]
    - title: Toteutuskatsaus
      type: Käy läpi
      description: Linuxin lähdekoodin tutkailua
      link: /pages/v02_toteutuskatsaus.rst
      tasks:
        - title: Omaan palautuslokeroonsa (kunhan aukeaa)
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v02
          requires: ["tiedostonpalautus_v02"]
    - title: Tutkimuskatsaus
      type: Käy läpi
      description: Tieteellisen julkaisun etsimistä ja lukemista
      link: /pages/v03_tutkimuskatsaus.rst
      tasks:
        - title: Omaan palautuslokeroonsa (kunhan aukeaa)
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v03
          requires: ["tiedostonpalautus_v03"]
    - title: Tuunaa tenttisi
      type: Käy läpi
      description: Osaamistavoitteita vastaavien, tämän vuoden kysymysformaatin mukaisten, tenttitehtävien miettiminen
      link: /pages/v04_tuunaa_tenttisi.rst
      tasks:
        - title: Omaan palautuslokeroonsa
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v04
          requires: ["tiedostonpalautus_v04"]
    - title: Skriptimpi
      type: Käy läpi
      description: Viime vuoden skriptidemo muokkaamattomana kaikessa karuudessaan
      link: /pages/v05_skriptimpi.rst
      tasks:
        - title: Omaan palautuslokeroonsa
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v05
          requires: ["tiedostonpalautus_v05"]
    - title: Skriptein
      type: Käy läpi
      description: Toinen viime vuoden skriptidemo muokkaamattomana kaikessa karuudessaan
      link: /pages/v06_skriptein.rst
      tasks:
        - title: Omaan palautuslokeroonsa (kunhan aukeaa)
          type: Palauta demon soveltavassa tehtävässä syntyvä tiedosto
          link: /pages/demot.md#vastaustiedosto_v06
          requires: ["tiedostonpalautus_v06"]

~~~~

~~~~{#itka203viimeistely plugin="taskview"}
- title: Viimeistely
  description: |
    Varmista ennen tenttiä
  tasks:
    - title: kertausluennolla
      type: Ole paikalla
      link: https://yousource.it.jyu.fi/itka203-kurssimateriaalikehitys/itka203-kurssimateriaali-avoin/blobs/master/luentosuunnitelma_2015.txt
      description: |
        (tai vähintään katso video ja tarkista muistiinpanot) Todennäaköisesti katsotaan tärppejä ja kerrotaan vielä kerran, miten kurssista pääsee läpi, jos on vielä tässäkin vaiheessa mukana.
    - title: kurssikuvaus ja osaamistavoitteet
      type: Käy läpi
      description: vielä kertaalleen
      link: http://users.jyu.fi/~nieminen/kj15/osaamistavoitteet.html
      tasks:
        - title: kurssin osaamistavoitteista
          type: Olen saavuttanut tavoittelemani osajoukon
          link: http://users.jyu.fi/~nieminen/kj15/osaamistavoitteet.html
          checkable: "saavuttanut_osaamistavoitteet"
          requires: ["saavuttanut_osaamistavoitteet"]
    - title: tenttitilaisuuteen
      type: Olen ilmoittautunut
      description: korpissa
      link: https://korppi.jyu.fi/kotka/r.jsp?course=165637
      tasks:
        - title: tenttitilaisuuteen
          type: Olen ilmoittautunut
          link: https://korppi.jyu.fi/kotka/r.jsp?course=165637
          checkable: "ilmoittautunut_tenttiin"
          requires: ["ilmoittautunut_tenttiin"]
~~~~


# Palautuslokerot pakollisille tehtäville 1-8

~~~~ {#vastaustiedosto_d01 plugin="uploader"}
prompt: | 
    Demon 1 palautettava tiedosto. (Tervetuloa pilottikäyttäjiksi! Palautus on auki; tutkaillaan teknisiä ongelmia sitten, kun/jos niitä ilmenee. )
tag: tiedostonpalautus_d01
~~~~

~~~~ {#vastaustiedosto_d02 plugin="uploader"}
prompt: | 
    Demon 2 palautettava tiedosto.
tag: tiedostonpalautus_d02
~~~~

~~~~ {#vastaustiedosto_d03 plugin="uploader"}
prompt: | 
    Demon 3 palautettava tiedosto.
tag: tiedostonpalautus_d03
~~~~

~~~~ {#vastaustiedosto_d04 plugin="uploader"}
prompt: | 
    Demon 4 palautettava tiedosto eli muokkaamasi 'merkkijono.c'.
tag: tiedostonpalautus_d04
~~~~

~~~~ {#vastaustiedosto_d05 plugin="uploader"}
prompt: | 
    Demon 5 palautettava tiedosto eli muokkaamasi 'd05_vastaus.txt'.
tag: tiedostonpalautus_d05
~~~~

~~~~ {#vastaustiedosto_d06 plugin="uploader"}
prompt: | 
    Demon 6 palautettava tiedosto eli mallin perusteella tekemäsi 'd06.sh'.
tag: tiedostonpalautus_d06
~~~~


# Palautuslokerot vapaaehtoisille bonus-tehtäville

~~~~ {#vastaustiedosto_v01 plugin="uploader"}
prompt: | 
    Bonusdemon 1 palautettava tiedosto.
tag: tiedostonpalautus_v01
~~~~

~~~~ {#vastaustiedosto_v02 plugin="uploader"}
prompt: | 
    Bonusdemon 2 palautettava tiedosto.
tag: tiedostonpalautus_v02
~~~~

~~~~ {#vastaustiedosto_v03 plugin="uploader"}
prompt: | 
    Bonusdemon 3 palautettava tiedosto.
tag: tiedostonpalautus_v03
~~~~

~~~~ {#vastaustiedosto_v04 plugin="uploader"}
prompt: | 
    Bonusdemon 4 palautettava tiedosto.
tag: tiedostonpalautus_v04
~~~~


~~~~ {#vastaustiedosto_v05 plugin="uploader"}
prompt: | 
    Bonusdemon 5 palautettava tiedosto.
tag: tiedostonpalautus_v05
~~~~


~~~~ {#vastaustiedosto_v06 plugin="uploader"}
prompt: | 
    Bonusdemon 6 palautettava tiedosto.
tag: tiedostonpalautus_v06
~~~~

